
/*     WINDESK   Version 1.00.07   5/20/93    */

#include "windows.h"
#include "winuser.h"
#include "windesk.h"

FARPROC lpAbortDlg, lpAbortProc;

CHOOSEFONT cf;
LOGFONT lf;
OPENFILENAME ofn;
PAINTSTRUCT ps;
POINT p;
RECT Rect;
SYSTEM_INFO si;

HANDLE hAccTable;
HANDLE hInst;
HANDLE hProcess;
HDC hDC;
HFONT hgFont;
HPEN hPen;
HWND hwnd;
HWND hEditWnd;
HWND hBeep;
HWND hBorderC;
HWND hBorderM;
HWND hBorderP;
HWND hExit;
HWND hFast;
HWND hGridC;
HWND hGridM;
HWND hGridP;
HWND hHelp;
HWND hIconFont;
HWND hIconHp;
HWND hIconHc;
HWND hIconHm;
HWND hIconVp;
HWND hIconVc;
HWND hIconVm;
HWND hKeyDp;
HWND hKeyDc;
HWND hKeyDm;
HWND hKeySp;
HWND hKeySc;
HWND hKeySm;
HWND hMenu;
HWND hMouse;
HWND hMouSpdP;
HWND hMouSpdC;
HWND hMouSpdM;
HWND hScreen;
HWND hSystem;
HWND hWallPaper;
HWND hWrap;
BOOL bBeep;
BOOL bFast;
BOOL bMenu;
BOOL bMenu2;
BOOL bMouse=FALSE;
BOOL bScreen;
BOOL bTest;
BOOL bWrap;
DWORD dwResults=80;
DWORD dwStyle;
DWORD dwStyleEx;
DWORD dwTextColor;
int iBorder;
int iDeskX;
int iDeskY;
int iDeskW;
int iDeskH;
int iGrid;
int Heigth;
int iIconH;
int iIconV;
int iIconV2;
int iKeyD;
int iKeyS;
int iMouse[2];
int iTest;
int Width;
char szFileName[MAXFILESIZE];
char szFileTitle[MAXFILESIZE];
char szTemp[128];
char szTemp2[128];
char szUserName[128];
char szFilterSpec[128] = "Bitmap Files (*.BMP)\0*.BMP\0";

int PASCAL WinMain(hInstance,hPrevInstance,lpCmdLine,nCmdShow)
HANDLE hInstance;
HANDLE hPrevInstance;
LPSTR lpCmdLine;
int nCmdShow;
{	MSG msg;
	hProcess=GetCurrentProcess();
	SetPriorityClass(hProcess, REALTIME_PRIORITY_CLASS);
	if ( !hPrevInstance ) {
		WNDCLASS	wc;
		wc.style = 0;
		wc.lpfnWndProc = MainWndProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = 0;
		wc.hInstance = hInstance;
		wc.hIcon = LoadIcon ( hInstance,"Icon" );
		wc.hCursor = LoadCursor ( NULL, IDC_ARROW );
		wc.hbrBackground = GetStockObject(LTGRAY_BRUSH);
		wc.lpszMenuName = "WINDESKMenu";
		wc.lpszClassName = "WINDESKWClass";
		if(!RegisterClass(&wc))
			return(FALSE);}
	SystemParametersInfo ( SPI_GETICONTITLELOGFONT, sizeof(lf), (LPLOGFONT) & lf, 0 );
	SystemParametersInfo ( SPI_GETMENUDROPALIGNMENT, 0, (LPBOOL) & bMenu2, 0);
	SystemParametersInfo ( SPI_ICONVERTICALSPACING, 0, (LPINT) & iIconV2, 0 );
	GetUserName ( (LPTSTR) & szUserName, (LPDWORD) & dwResults );
	iDeskX = GetPrivateProfileInt ( ( LPCTSTR ) & szUserName, "DeskX", 260, "Solution.ini" );
	iDeskY = GetPrivateProfileInt ( ( LPCTSTR ) & szUserName, "DeskY", 116, "Solution.ini" );
	iDeskW = GetPrivateProfileInt ( ( LPCTSTR ) & szUserName, "DeskW", 375, "Solution.ini" );
	iDeskH = GetPrivateProfileInt ( ( LPCTSTR ) & szUserName, "DeskH", 358, "Solution.ini" );
	hInst=hInstance;
	hAccTable=LoadAccelerators(hInst,"WINDESKAcc");
	dwStyle=WS_OVERLAPPEDWINDOW;
	hwnd=CreateWindow("WINDESKWClass", "WINDESK", dwStyle, iDeskX, iDeskY, iDeskW, iDeskH, NULL,NULL,hInstance,NULL);
	if(!hwnd)
		return(FALSE);
	dwStyle=WS_CHILD | WS_VISIBLE | WS_DISABLED | LBS_NOINTEGRALHEIGHT ;
	dwStyleEx=WS_EX_TOPMOST;
	GetClientRect(hwnd,(LPRECT)&Rect);
	Width=(Rect.right-Rect.left);
	Heigth=(Rect.bottom-Rect.top);
	hEditWnd=CreateWindowEx(dwStyleEx,"Listbox",NULL,dwStyle,163,0,Width-163,Heigth,hwnd,(HMENU)IDC_EDIT,hInst,NULL);
	if ( !hEditWnd ) {
		DestroyWindow ( hwnd ) ;
		return ( 0 ) ; }
	dwStyle = WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON;
	hIconHm = CreateWindowEx ( dwStyleEx, "Button", "<-", dwStyle, 2, 0, 20, 16, hwnd, (HMENU)IDM_ICONHM, hInst, NULL );
	hIconHc = CreateWindowEx ( dwStyleEx, "Button", "Set H Icon space", dwStyle, 22, 0, 118, 16, hwnd, (HMENU)IDM_ICONHC, hInst, NULL );
	hIconHp = CreateWindowEx ( dwStyleEx, "Button", "+>", dwStyle, 140, 0, 20, 16, hwnd, (HMENU)IDM_ICONHP, hInst, NULL );
	hIconVm = CreateWindowEx ( dwStyleEx, "Button", "<-", dwStyle, 2, 16, 20, 16, hwnd, (HMENU)IDM_ICONVM, hInst, NULL );
	hIconVc = CreateWindowEx ( dwStyleEx, "Button", "Set V Icon space", dwStyle, 22, 16, 118, 16, hwnd, (HMENU)IDM_ICONVC, hInst, NULL );
	hIconVp = CreateWindowEx ( dwStyleEx, "Button", "+>", dwStyle, 140, 16, 20, 16, hwnd, (HMENU)IDM_ICONVP, hInst, NULL );
	hBorderM = CreateWindowEx ( dwStyleEx, "Button", "<-", dwStyle, 2, 32, 20, 16, hwnd, (HMENU)IDM_BORDERM, hInst, NULL );
	hBorderC = CreateWindowEx ( dwStyleEx, "Button", "Set Border width", dwStyle, 22, 32, 118, 16, hwnd, (HMENU)IDM_BORDERC, hInst, NULL );
	hBorderP = CreateWindowEx ( dwStyleEx, "Button", "+>", dwStyle, 140, 32, 20, 16, hwnd, (HMENU)IDM_BORDERP, hInst, NULL );
	hGridM = CreateWindowEx ( dwStyleEx, "Button", "<-", dwStyle, 2, 48, 20, 16, hwnd, (HMENU)IDM_GRIDM, hInst, NULL );
	hGridC = CreateWindowEx ( dwStyleEx, "Button", "Set Grid size", dwStyle, 22, 48, 118, 16, hwnd, (HMENU)IDM_GRIDC, hInst, NULL );
	hGridP = CreateWindowEx ( dwStyleEx, "Button", "+>", dwStyle, 140, 48, 20, 16, hwnd, (HMENU)IDM_GRIDP, hInst, NULL );
	hKeyDm = CreateWindowEx ( dwStyleEx, "Button", "<-", dwStyle, 2, 64, 20, 16, hwnd, (HMENU)IDM_KEYDM, hInst, NULL );
	hKeyDc = CreateWindowEx ( dwStyleEx, "Button", "Set Key delay", dwStyle, 22, 64, 118, 16, hwnd, (HMENU)IDM_KEYDC, hInst, NULL );
	hKeyDp = CreateWindowEx ( dwStyleEx, "Button", "+>", dwStyle, 140, 64, 20, 16, hwnd, (HMENU)IDM_KEYDP, hInst, NULL );
	hKeySm = CreateWindowEx ( dwStyleEx, "Button", "<-", dwStyle, 2, 80, 20, 16, hwnd, (HMENU)IDM_KEYSM, hInst, NULL );
	hKeySc = CreateWindowEx ( dwStyleEx, "Button", "Set Key speed", dwStyle, 22, 80, 118, 16, hwnd, (HMENU)IDM_KEYSC, hInst, NULL );
	hKeySp = CreateWindowEx ( dwStyleEx, "Button", "+>", dwStyle, 140, 80, 20, 16, hwnd, (HMENU)IDM_KEYSP, hInst, NULL );
	hMouSpdM = CreateWindowEx ( dwStyleEx, "Button", "<-", dwStyle, 2, 96, 20, 16, hwnd, (HMENU)IDM_MOUSPDM, hInst, NULL );
	hMouSpdC = CreateWindowEx ( dwStyleEx, "Button", "Set mouse speed", dwStyle, 22, 96, 118, 16, hwnd, (HMENU)IDM_MOUSPDC, hInst, NULL );
	hMouSpdP = CreateWindowEx ( dwStyleEx, "Button", "+>", dwStyle, 140, 96, 20, 16, hwnd, (HMENU)IDM_MOUSPDP, hInst, NULL );	
	hIconFont = CreateWindowEx ( dwStyleEx, "Button", "Set Icon Font", dwStyle, 2, 112, 158, 18, hwnd, (HMENU)IDM_ICONFONT, hInst, NULL );
	hWallPaper = CreateWindowEx ( dwStyleEx, "Button", "Set Wallpaper", dwStyle, 2, 130, 158, 18, hwnd, (HMENU)IDM_WALLPAPER, hInst, NULL );
	hHelp = CreateWindowEx ( dwStyleEx, "Button", "Help", dwStyle, 2, 148, 158, 18, hwnd, (HMENU)IDM_HELP, hInst, NULL );
	hBeep = CreateWindowEx ( dwStyleEx, "Button", "", dwStyle, 2, 166, 158, 18, hwnd, (HMENU)IDM_BEEP, hInst, NULL );
	hFast = CreateWindowEx ( dwStyleEx, "Button", "", dwStyle, 2, 184, 158, 18, hwnd, (HMENU)IDM_FAST, hInst, NULL );
	hWrap = CreateWindowEx ( dwStyleEx, "Button", "", dwStyle, 2, 202, 158, 18, hwnd, (HMENU)IDM_WRAP, hInst, NULL );
	hMenu = CreateWindowEx ( dwStyleEx, "Button", "", dwStyle, 2, 220, 158, 18, hwnd, (HMENU)IDM_MENU, hInst, NULL );
	hMouse = CreateWindowEx ( dwStyleEx, "Button", "", dwStyle, 2, 238, 158, 18, hwnd, (HMENU)IDM_MOUSE, hInst, NULL );
	hScreen = CreateWindowEx ( dwStyleEx, "Button", "", dwStyle, 2, 256, 158, 18, hwnd, (HMENU)IDM_SCREEN, hInst, NULL );
	hSystem = CreateWindowEx ( dwStyleEx, "Button", "Show System Info", dwStyle, 2, 274, 158, 18, hwnd, (HMENU)IDM_SYSTEM, hInst, NULL );
	hExit = CreateWindowEx ( dwStyleEx, "Button", "Exit", dwStyle, 2, 292, 158, 18, hwnd, (HMENU)IDM_EXIT, hInst, NULL );
	SystemParametersInfo ( SPI_ICONHORIZONTALSPACING, 0, (LPINT) & iIconH, 0 );
	wsprintf ( szTemp, "Horizontal Icon Spacing is %i", iIconH );
	SendMessage ( hEditWnd, LB_INSERTSTRING, 0, (LPARAM) (LPCTSTR) & szTemp );
	SystemParametersInfo ( SPI_ICONVERTICALSPACING, 0, (LPINT) & iIconV, 0 );
	wsprintf ( szTemp, "Vertical Icon Spacing is %i", iIconV );
	SendMessage ( hEditWnd, LB_INSERTSTRING, 1, (LPARAM) (LPCTSTR) & szTemp );
	SystemParametersInfo ( SPI_GETBORDER, 0, (LPINT) & iBorder, 0 );
	wsprintf ( szTemp, "Current Border Width is %i", iBorder );
	SendMessage ( hEditWnd, LB_INSERTSTRING, 2, (LPARAM) (LPCTSTR) & szTemp );
	SystemParametersInfo ( SPI_GETGRIDGRANULARITY, 0, (LPINT) & iGrid, 0 );
	wsprintf ( szTemp, "Current Grid Granularity is %i", iGrid );
	SendMessage ( hEditWnd, LB_INSERTSTRING, 3, (LPARAM) (LPCTSTR) & szTemp );
	SystemParametersInfo ( SPI_GETKEYBOARDDELAY, 0, (LPINT) & iKeyD, 0 );
	wsprintf ( szTemp, "Current Keyboard Delay is %i", iKeyD );
	SendMessage ( hEditWnd, LB_INSERTSTRING, 4, (LPARAM) (LPCTSTR) & szTemp );
	SystemParametersInfo ( SPI_GETKEYBOARDSPEED, 0, (LPINT) & iKeyS, 0 );
	wsprintf ( szTemp, "Current Keyboard Speed is %i", iKeyS );
	SendMessage ( hEditWnd, LB_INSERTSTRING, 5, (LPARAM) (LPCTSTR) & szTemp );
	SystemParametersInfo ( SPI_GETMOUSE, 0, (LPINT) & iMouse[0], 0 );
	wsprintf ( szTemp, "Current Mouse Speed is %i", iMouse[2] );
	SendMessage ( hEditWnd, LB_INSERTSTRING, 6, (LPARAM) (LPCTSTR) & szTemp );
	SystemParametersInfo ( SPI_GETICONTITLELOGFONT, sizeof(lf), (LPLOGFONT) & lf, 0 );
	if (lf.lfHeight<0)
		wsprintf ( szTemp, "Icon Font is %s %i pt", (LPCTSTR) & lf.lfFaceName, -MulDiv(lf.lfHeight,3,4));
	else
		wsprintf ( szTemp, "Icon Font is %s %i pt", (LPCTSTR) & lf.lfFaceName, MulDiv(lf.lfHeight,2,3));
	SendMessage ( hEditWnd, LB_INSERTSTRING, 7, (LPARAM) (LPCTSTR) & szTemp );
	wsprintf ( szTemp2, "%s", "");
	SendMessage ( hEditWnd, LB_INSERTSTRING, 8, (LPARAM) (LPCTSTR) & szTemp2 );
	SystemParametersInfo ( SPI_GETBEEP, 0, (LPBOOL) & bBeep, 0 );
	if (bBeep)
		SetWindowText ( hBeep, "Beep is On" );
	else
		SetWindowText ( hBeep, "Beep is Off" );
	SystemParametersInfo ( SPI_GETFASTTASKSWITCH, 0, (LPBOOL) & bFast, 0);
	if (bFast)
		SetWindowText ( hFast, "Fast Task Switch is On" );
	else
		SetWindowText ( hFast, "FastTask Switch is Off" );
	SystemParametersInfo ( SPI_GETICONTITLEWRAP, 0, (LPBOOL) & bWrap, 0);
	if (bWrap)
		SetWindowText ( hWrap, "Icon Text Wrap is On" );
	else
		SetWindowText ( hWrap, "Icon Text Wrap is Off" );
	SystemParametersInfo ( SPI_GETMENUDROPALIGNMENT, 0, (LPBOOL) & bMenu, 0);
	if (bMenu)
		SetWindowText ( hMenu, "Menu Align is Right" );
	else
		SetWindowText ( hMenu, "Menu Align is Left" );
	SetWindowText ( hMouse, "Mouse Buttons Normal" );
	SystemParametersInfo ( SPI_GETSCREENSAVEACTIVE, 0, (LPBOOL) & bScreen, 0);
	if (bScreen)
		SetWindowText ( hScreen, "Screen Save is On" );
	else
		SetWindowText ( hBeep, "ScreenSave is Off" );
	ShowWindow(hwnd,nCmdShow);
	UpdateWindow(hwnd);
	SetPriorityClass(hProcess, NORMAL_PRIORITY_CLASS);
	while(GetMessage(&msg,NULL,0,0)){
		if(!TranslateAccelerator(hwnd,hAccTable,&msg)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);}}
	return(msg.wParam);
}

long FAR PASCAL MainWndProc ( hWnd, message, wParam, lParam )
HWND hWnd;
UINT message;
WPARAM wParam;
LPARAM lParam;
{	FARPROC lpProcAbout;
	switch ( message ) {
		case WM_COMMAND :
			switch (LOWORD(wParam)){		/* THE <(LOWORD)> WAS ADDED FOR COMPATIBILITY WITH NT */
				case IDM_ICONHP :
					if (iIconH<99)
						iIconH++;
					wsprintf ( szTemp, "Do you want spacing of %i ?", iIconH );
					SendMessage ( hEditWnd, LB_DELETESTRING, 0, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 0, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_ICONHM :
					if (iIconH>0)
						iIconH--;
					wsprintf ( szTemp, "Do you want spacing of %i ?", iIconH );
					SendMessage ( hEditWnd, LB_DELETESTRING, 0, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 0, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_ICONHC :
					wsprintf ( szTemp, "Horizontal Icon Spacing is %i", iIconH );
					SendMessage ( hEditWnd, LB_DELETESTRING, 0, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 0, (LPARAM) (LPCTSTR) & szTemp );
					SystemParametersInfo ( SPI_ICONHORIZONTALSPACING, (UINT) iIconH, 0, 3 );
					SetFocus ( hIconHp );
					break;					
				case IDM_ICONVP :
					if (iIconV<99)
						iIconV++;
					wsprintf ( szTemp, "Do you want spacing of %i ?", iIconV );
					SendMessage ( hEditWnd, LB_DELETESTRING, 1, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 1, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_ICONVM :
					if (iIconV>0)
						iIconV--;
					wsprintf ( szTemp, "Do you want spacing of %i ?", iIconV );
					SendMessage ( hEditWnd, LB_DELETESTRING, 1, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 1, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_ICONVC :
					wsprintf ( szTemp, "Vertical Icon Spacing is %i", iIconV );
					SendMessage ( hEditWnd, LB_DELETESTRING, 1, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 1, (LPARAM) (LPCTSTR) & szTemp );
					SystemParametersInfo ( SPI_ICONVERTICALSPACING, (UINT) iIconV, 0, 3 );
					SetFocus ( hIconVp );
					break;
				case IDM_BORDERP :
					if (iBorder<19)
						iBorder++;
					wsprintf ( szTemp, "Do you want a width of %i ?", iBorder );
					SendMessage ( hEditWnd, LB_DELETESTRING, 2, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 2, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_BORDERM :
					if (iBorder>1)
						iBorder--;
					wsprintf ( szTemp, "Do you want a width of %i ?", iBorder );
					SendMessage ( hEditWnd, LB_DELETESTRING, 2, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 2, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_BORDERC :
					wsprintf ( szTemp, "Current Border Width is %i", iBorder );
					SendMessage ( hEditWnd, LB_DELETESTRING, 2, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 2, (LPARAM) (LPCTSTR) & szTemp );
					SystemParametersInfo ( SPI_SETBORDER, (UINT) iBorder, 0, 3 );
					SetFocus ( hIconVp );
					break;
				case IDM_GRIDP :
					if (iGrid<15)
						iGrid++;
					wsprintf ( szTemp, "Do you want a grid of %i ?", iGrid );
					SendMessage ( hEditWnd, LB_DELETESTRING, 3, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 3, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_GRIDM :
					if (iGrid>0)
						iGrid--;
					wsprintf ( szTemp, "Do you want a grid of %i ?", iGrid );
					SendMessage ( hEditWnd, LB_DELETESTRING, 3, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 3, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_GRIDC :
					wsprintf ( szTemp, "Current Grid Granularity is %i", iGrid );
					SendMessage ( hEditWnd, LB_DELETESTRING, 3, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 3, (LPARAM) (LPCTSTR) & szTemp );
					SystemParametersInfo ( SPI_SETGRIDGRANULARITY, (UINT) iGrid, 0, 3 );
					SetFocus ( hIconVp );
					break;
				case IDM_KEYDP :
					if (iKeyD<3)
						iKeyD++;
					wsprintf ( szTemp, "Do you want a delay of %i ?", iKeyD );
					SendMessage ( hEditWnd, LB_DELETESTRING, 4, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 4, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_KEYDM :
					if (iKeyD>0)
						iKeyD--;
					wsprintf ( szTemp, "Do you want a delay of %i ?", iKeyD );
					SendMessage ( hEditWnd, LB_DELETESTRING, 4, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 4, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_KEYDC :
					wsprintf ( szTemp, "Current Keyboard Delay is %i", iKeyD );
					SendMessage ( hEditWnd, LB_DELETESTRING, 4, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 4, (LPARAM) (LPCTSTR) & szTemp );
					SystemParametersInfo ( SPI_SETKEYBOARDDELAY, (UINT) iKeyD, 0, 3 );
					SetFocus ( hIconVp );
					break;
				case IDM_KEYSP :
					if (iKeyS<31)
						iKeyS++;
					wsprintf ( szTemp, "Do you want a speed of %i ?", iKeyS );
					SendMessage ( hEditWnd, LB_DELETESTRING, 5, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 5, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_KEYSM :
					if (iKeyS>0)
						iKeyS--;
					wsprintf ( szTemp, "Do you want a speed of %i ?", iKeyS );
					SendMessage ( hEditWnd, LB_DELETESTRING, 5, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 5, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_KEYSC :
					wsprintf ( szTemp, "Current Keyboard Speed is %i", iKeyS );
					SendMessage ( hEditWnd, LB_DELETESTRING, 5, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 5, (LPARAM) (LPCTSTR) & szTemp );
					SystemParametersInfo ( SPI_SETKEYBOARDSPEED, (UINT) iKeyS, 0, 3 );
					SetFocus ( hIconVp );
					break;
				case IDM_MOUSPDP :
					if (iMouse[2]<2)
						iMouse[2]++;
					wsprintf ( szTemp, "Do you want a speed of %i ?", iMouse[2] );
					SendMessage ( hEditWnd, LB_DELETESTRING, 6, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 6, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_MOUSPDM :
					if (iMouse[2]>0)
						iMouse[2]--;
					wsprintf ( szTemp, "Do you want a speed of %i ?", iMouse[2] );
					SendMessage ( hEditWnd, LB_DELETESTRING, 6, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 6, (LPARAM) (LPCTSTR) & szTemp );
					break;
				case IDM_MOUSPDC :
					wsprintf ( szTemp, "Current Mouse Speed is %i", iMouse[2] );
					SendMessage ( hEditWnd, LB_DELETESTRING, 6, 0 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 6, (LPARAM) (LPCTSTR) & szTemp );
					SystemParametersInfo ( SPI_SETMOUSE, 0, (LPINT) & iMouse[0], 3 );
					SetFocus ( hIconVp );
					break;
				case IDM_BEEP :
					if (bBeep){
						SystemParametersInfo ( SPI_SETBEEP, FALSE, 0, 3);
						SetWindowText ( hBeep, "Beep is Off");
						bBeep = FALSE;}
					else{
						SystemParametersInfo ( SPI_SETBEEP, TRUE, 0, 3);
						SetWindowText ( hBeep, "Beep is On");
						bBeep = TRUE;}
					SetFocus ( hIconHp );
					break;
				case IDM_FAST :
					if (bFast){
						SystemParametersInfo ( SPI_SETFASTTASKSWITCH, FALSE, 0, 3);
						SetWindowText ( hFast, "Fast Task Switch is Off");
						bFast = FALSE;}
					else{
						SystemParametersInfo ( SPI_SETFASTTASKSWITCH, TRUE, 0, 3);
						SetWindowText ( hFast, "Fast Task Switch is On");
						bFast = TRUE;}
					SetFocus ( hIconHp );
					break;
				case IDM_WRAP :
					if (bWrap){
						SystemParametersInfo ( SPI_SETICONTITLEWRAP, FALSE, 0, 3);
						SetWindowText ( hWrap, "Icon Text Wrap is Off");
						bWrap = FALSE;}
					else{
						SystemParametersInfo ( SPI_SETICONTITLEWRAP, TRUE, 0, 3);
						SetWindowText ( hWrap, "Icon Text Wrap is On");
						bWrap = TRUE;}
					SetFocus ( hIconHp );
					break;
				case IDM_MENU :
					if (bMenu){
						SystemParametersInfo ( SPI_SETMENUDROPALIGNMENT, FALSE, 0, 3);
						SetWindowText ( hMenu, "Menu Align is Left");
						bMenu = FALSE;}
					else{
						SystemParametersInfo ( SPI_SETMENUDROPALIGNMENT, TRUE, 0, 3);
						SetWindowText ( hMenu, "Menu Align is Right");
						bMenu = TRUE;}
					SetFocus ( hIconHp );
					break;
				case IDM_MOUSE :
					if (bMouse){
						SystemParametersInfo ( SPI_SETMOUSEBUTTONSWAP, FALSE, 0, 3);
						SetWindowText ( hMouse, "Mouse Buttons Normal");
						bMouse = FALSE;}
					else{
						SystemParametersInfo ( SPI_SETMOUSEBUTTONSWAP, TRUE, 0, 3);
						SetWindowText ( hMouse, "Mouse Buttons Swap'd");
						bMouse = TRUE;}
					SetFocus ( hIconHp );
					break;
				case IDM_SCREEN :
					if (bScreen){
						SystemParametersInfo ( SPI_SETSCREENSAVEACTIVE, FALSE, 0, 3);
						SetWindowText ( hScreen, "Screen Save is Off");
						bScreen = FALSE;}
					else{
						SystemParametersInfo ( SPI_SETSCREENSAVEACTIVE, TRUE, 0, 3);
						SetWindowText ( hScreen, "Screen Save in On");
						bScreen = TRUE;}
					SetFocus ( hIconHp );
					break;
				case IDM_ICONFONT :
					cf.lStructSize = sizeof ( CHOOSEFONT ) ;
					cf.hwndOwner = hwnd ;
					cf.lpLogFont = (LPLOGFONT) & lf ;
					cf.Flags = CF_BOTH | CF_EFFECTS | CF_INITTOLOGFONTSTRUCT ;
					cf.rgbColors = RGB ( 0, 0, 0 ) ;
					cf.nFontType = SCREEN_FONTTYPE ;
					if (ChooseFont (&cf)) {
						if (lf.lfHeight<0)
							wsprintf ( szTemp, "Icon Font is %s %i pt", (LPCTSTR) & lf.lfFaceName, -MulDiv(lf.lfHeight,3,4));
						else
							wsprintf ( szTemp, "Icon Font is %s %i pt", (LPCTSTR) & lf.lfFaceName, lf.lfHeight);
						SendMessage ( hEditWnd, LB_DELETESTRING, 7, 0 );
						SendMessage ( hEditWnd, LB_INSERTSTRING, 7, (LPARAM) (LPCTSTR) & szTemp );
						SystemParametersInfo ( SPI_SETICONTITLELOGFONT, sizeof(lf), (LPLOGFONT) & lf, 3);}					
					SetFocus ( hIconHp );
					break;
				case IDM_WALLPAPER :
					ofn.lStructSize = sizeof ( OPENFILENAME ) ;
					ofn.hwndOwner = hWnd ;
					ofn.lpstrFilter  = szFilterSpec ;
					ofn.lpstrCustomFilter = NULL ;
					ofn.nMaxCustFilter = 0 ;
					ofn.nFilterIndex = 1 ;
					ofn.lpstrFile = szFileName ;
					ofn.nMaxFile = MAXFILESIZE ;
					ofn.lpstrInitialDir = NULL ;
					ofn.lpstrFileTitle = szFileTitle ;
					ofn.nMaxFileTitle = MAXFILESIZE ;
					ofn.lpstrTitle = "Get Wallpaper" ;
					ofn.lpstrDefExt = "bmp" ;
					ofn.Flags = OFN_NOCHANGEDIR ;
					GetOpenFileName ((LPOPENFILENAME) & ofn );
					SystemParametersInfo ( SPI_SETDESKWALLPAPER, 0, (LPTSTR) & szFileName, 3);
					SetFocus ( hIconHp );
					break;
				case IDM_SYSTEM :
					dwResults=80;
					wsprintf ( szTemp, "%s", "" );
					wsprintf ( szTemp2, "%s", "");
					GetComputerName ( (LPTSTR) &szTemp, (LPDWORD) & dwResults );
					wsprintf ( szTemp2, "Computer Name is %s", szTemp);
					SendMessage ( hEditWnd, LB_INSERTSTRING, 9, (LPARAM) (LPCTSTR) & szTemp2 );
					wsprintf ( szTemp2, "User Name is %s", szUserName);
					SendMessage ( hEditWnd, LB_INSERTSTRING, 10, (LPARAM) (LPCTSTR) & szTemp2 );
					GetSystemInfo ( (LPSYSTEM_INFO) & si );
					wsprintf ( szTemp2, "Processor Type is %d", si.dwProcessorType);
					SendMessage ( hEditWnd, LB_INSERTSTRING, 11, (LPARAM) (LPCTSTR) & szTemp2 );
					wsprintf ( szTemp2, "Number of CPUs is %d", si.dwNumberOfProcessors);
					SendMessage ( hEditWnd, LB_INSERTSTRING, 12, (LPARAM) (LPCTSTR) & szTemp2 );
					wsprintf ( szTemp2, "Manufacture ID is %d", si.dwOemId);
					SendMessage ( hEditWnd, LB_INSERTSTRING, 13, (LPARAM) (LPCTSTR) & szTemp2 );
					iTest=GetKeyboardType (0);
					if (iTest==0)
						wsprintf ( szTemp2, "Keyboard is %i type", iTest );
					if (iTest==1)
						wsprintf ( szTemp2, "Keyboard is %i key XT type", 83 );
					if (iTest==2)
						wsprintf ( szTemp2, "Keyboard is %i key Olivetti", 102 );
					if (iTest==3)
						wsprintf (szTemp2, "Keyboard is %i key AT type", 84 );
					if (iTest==4)
						wsprintf (szTemp2, "Keyboard is %i Enhanced", 101 );
					if (iTest>4)
						wsprintf ( szTemp2, "Keyboard is %i type", iTest );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 14, (LPARAM) (LPCTSTR) & szTemp2 );
					if (!GetSystemMetrics ( SM_MOUSEPRESENT ))
						wsprintf (szTemp2, "No Mouse is present%s", "");
					else
						wsprintf (szTemp2, "A Mouse is present%s", "");
					SendMessage ( hEditWnd, LB_INSERTSTRING, 15, (LPARAM) (LPCTSTR) & szTemp2 );
					if (!GetSystemMetrics ( SM_PENWINDOWS ))
						wsprintf (szTemp2, "No Pen Windows %s", "");
					else
						wsprintf (szTemp2, "Pen Windows is present%s", "");
					SendMessage ( hEditWnd, LB_INSERTSTRING, 16, (LPARAM) (LPCTSTR) & szTemp2 );
					GetSystemDirectory ( (LPTSTR) & szTemp, 260 );
					wsprintf ( szTemp2, "The System Directory is;%s", "");
					SendMessage ( hEditWnd, LB_INSERTSTRING, 17, (LPARAM) (LPCTSTR) & szTemp2 );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 18, (LPARAM) (LPCTSTR) & szTemp );
					wsprintf ( szTemp, "%s", "" );
					SendMessage ( hEditWnd, LB_INSERTSTRING, 19, (LPARAM) (LPCTSTR) & szTemp );
					SetFocus ( hIconHp );
					break;
				case IDM_HELP :
					iTest=MessageBox ( hWnd, "Ok, Ok, I am here ...\nDo you feel better now ?", "Help is on the way ...", MB_ICONEXCLAMATION | MB_YESNO);
					if (iTest==IDNO)
						MessageBox ( hWnd, "Well I don't know why not,\nI'm doing the best I can !!!", "Some people are never happy.", MB_ICONQUESTION );
					else
						MessageBox ( hWnd, "Thank you very much.\nIt's nice to be appreciated.", "Smile, you're on Candid Camera.", MB_ICONINFORMATION);
					SetFocus ( hIconHp );
					break;
				case IDM_ABOUT :
					lpProcAbout = MakeProcInstance (About, hInst);
					DialogBox (hInst, "AboutBox", hWnd, lpProcAbout);
					FreeProcInstance (lpProcAbout);
					break;
				case IDM_EXIT :
					p.x = 0;
					p.y = 0;
					ClientToScreen ( hWnd, (LPPOINT) & p ) ;
					iDeskX = p.x - 4 ;
					iDeskY = p.y - 42 ;
					GetClientRect ( hwnd, ( LPRECT) &Rect ) ;
					iDeskW = ( Rect.right - Rect.left ) + 8 ;
					iDeskH = ( Rect.bottom - Rect.top ) + 46  ;
					wsprintf ( szTemp, "%i", 1);
					WritePrivateProfileString ( ( LPCSTR ) & szUserName, "...", (LPCTSTR) & szTemp, "Solution.ini");
					wsprintf ( szTemp, "%i", iDeskX);
					WritePrivateProfileString ( ( LPCSTR ) & szUserName, "DeskX", (LPCTSTR) & szTemp, "Solution.ini");
					wsprintf ( szTemp, "%i", iDeskY);
					WritePrivateProfileString ( ( LPCSTR ) & szUserName, "DeskY", (LPCTSTR) & szTemp, "Solution.ini");
					wsprintf ( szTemp, "%i", iDeskH);
					WritePrivateProfileString ( ( LPCSTR ) & szUserName, "DeskH", (LPCTSTR) & szTemp, "Solution.ini");
					wsprintf ( szTemp, "%i", iDeskW);
					WritePrivateProfileString ( ( LPCSTR ) & szUserName, "DeskW", (LPCTSTR) & szTemp, "Solution.ini");
					DestroyWindow ( hWnd ) ;
					break ;
				default :
					return ( DefWindowProc ( hWnd, message, wParam, lParam ) ) ; }
			return (0);
		case WM_PAINT:
			hDC = BeginPaint(hwnd, (LPPAINTSTRUCT)&ps);
			MoveToEx(hDC, 162, 0, NULL);
			hPen = SelectObject(hDC, (HGDIOBJ)GetStockObject(BLACK_PEN));
			LineTo(hDC, 162, 480);
			EndPaint(hwnd, (LPPAINTSTRUCT)&ps);
			break;
		case WM_SIZE:
			MoveWindow ( hEditWnd, 163, 0, LOWORD ( lParam )-163, HIWORD ( lParam ), TRUE ) ;
			break;
		case WM_SETFOCUS:
			SetFocus(hEditWnd);
			break;
		case WM_QUERYENDSESSION :
			return (TRUE);
			break;
		case WM_CLOSE :
			DestroyWindow ( hWnd ) ;
			break ;
		case WM_DESTROY :
			PostQuitMessage ( 0 ) ;
			break ;
		default :
			return ( DefWindowProc ( hWnd, message, wParam, lParam ) ) ; }
	return ( 0 ) ;
}

BOOL FAR PASCAL About ( hDlg, message, wParam, lParam )
HWND hDlg ;
unsigned message ;
WORD wParam ;
LONG lParam ;
{	switch ( message ) {
        case WM_INITDIALOG :
            return ( TRUE ) ;
        case WM_COMMAND :
			if ( wParam == IDOK || wParam == IDCANCEL ) {
				EndDialog( hDlg, TRUE ) ;
                return ( TRUE ) ; }
            return ( TRUE ) ; }
    return ( FALSE ) ;
}
